#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include <windows.h>
#include <windowsx.h>
#include <sys\stat.h>
#include <sys\types.h>

#define MK_FP32(x)                      (x)
#define ROUND_UP_TO_EVEN(x) (((x) + 1) & ~1)
#define MCIMSGLEN 128

typedef struct
{
        char name[13];
        unsigned long size, offset;
} Item_T;

char wavehdr[40] = {0x52, 0x49, 0x46, 0x46, 0xa6, 0x6f, 0x00, 0x00, 0x57,
                    0x41, 0x56, 0x45, 0x66, 0x6d, 0x74, 0x20, 0x10, 0x00,
                    0x00, 0x00, 0x01, 0x00, 0x01, 0x00, 0x22, 0x56, 0x00,
                    0x00, 0x22, 0x56, 0x00, 0x00, 0x01, 0x00, 0x08, 0x00,
                    0x64, 0x61, 0x74, 0x61};
char datname[256] = "SN.DAT";
char itemfilename[256];
OPENFILENAME ofn;
Item_T item[4096];
int numitems, indexsize, indexoffset, curitem = -1;
int deviceid;
char header[4];

long FAR PASCAL WndProc(HWND hWnd, UINT msg, WPARAM wparam, LPARAM lparam);
void stopallnotes(void);
void loadinst(void);

int loaditem(char *name)
{
        long i, handle;

        for(i=0;i<numitems;i++)
                if (stricmp(name,item[i].name) == 0)
                        break;
        
        if ((handle = open(datname,O_BINARY|O_RDONLY,S_IREAD)) == -1)
                return(-1);

        lseek(handle, item[i].offset, SEEK_SET);
        return(handle);
}

void readitem(long handle, void *buf, long size)
{
        char tempbuf[80];
        long l;

        l = read(handle, buf, size);
        if (l < size)
        {
                sprintf(tempbuf, "Read only %d of %d", l, size);
                MessageBox(NULL,tempbuf,"readitem()",MB_OK);
        }
}

void closeitem(long handle)
{
        close(handle);
}

void loadindex(char *filename)
{
        int fil;

        if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
                return;

        read(fil,&header[0],4);
        if (memcmp(header,"DAT\x1A", 4) != 0) return;

        read(fil,&numitems,2);
        read(fil,&indexoffset,4);
        read(fil,&indexsize,4);

        lseek(fil, indexoffset, SEEK_SET);
        read(fil,&item[0],indexsize);
        close(fil);
}

int PASCAL WinMain(HINSTANCE instance, HINSTANCE previnstance, LPSTR cmdline, int cmdshow)
{
        HWND hwnd;
        MSG msg;
        WNDCLASS wndclass;

        if (!previnstance)
        {
            wndclass.style = CS_HREDRAW | CS_VREDRAW;
            wndclass.lpfnWndProc = (LPVOID)WndProc;
            wndclass.cbClsExtra = 0;
            wndclass.cbWndExtra = 0;
            wndclass.hInstance = instance;
            wndclass.hIcon = LoadIcon(instance, IDI_APPLICATION);
            wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
            wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
            wndclass.lpszMenuName = "DATMENU";
            wndclass.lpszClassName = "DatView";
            RegisterClass(&wndclass);
        }

        if (cmdline[0] != 0) strcpy(datname, cmdline);
        loadindex(datname);
        hwnd = CreateWindow("DatView", "DATVIEW", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 512, 388, NULL, NULL, instance, NULL);
        ShowWindow(hwnd, cmdshow);
        UpdateWindow(hwnd);
        while (GetMessage(&msg, NULL, 0, 0)) {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
        }
        return(msg.wParam);
}

void playwave(HWND hWnd)
{
        MCI_OPEN_PARMS open;
        MCI_PLAY_PARMS play;
        MCIERROR MCI_Error;
        char mcimsg[MCIMSGLEN+1];

        open.dwCallback = (DWORD)hWnd;
        open.lpstrDeviceType = "waveaudio";
        open.lpstrElementName = ".\\temp.wav";

        MCI_Error = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(DWORD)&open);
        if (MCI_Error)
        {
                mciGetErrorString(MCI_Error,mcimsg,MCIMSGLEN);
                MessageBox(hWnd,mcimsg,"Error",MB_ICONSTOP|MB_OK);
                return;
        }
        deviceid = open.wDeviceID;
        play.dwCallback = (DWORD)hWnd;

        MCI_Error = mciSendCommand(deviceid, MCI_PLAY, MCI_NOTIFY,(DWORD)&play);
        if (MCI_Error)
        {
                mciGetErrorString(MCI_Error,mcimsg,MCIMSGLEN);
                MessageBox(hWnd,mcimsg,"Error",MB_ICONSTOP|MB_OK);
        }
}

void playmidi(HWND hWnd)
{
        MCI_OPEN_PARMS open;
        MCI_PLAY_PARMS play;
        MCIERROR MCI_Error;
        char mcimsg[MCIMSGLEN+1];

        open.dwCallback = (DWORD)hWnd;
        open.lpstrDeviceType = "sequencer";
        open.lpstrElementName = ".\\temp.mid";

        MCI_Error = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE|MCI_OPEN_ELEMENT,(DWORD)&open);
        if (MCI_Error)
        {
                mciGetErrorString(MCI_Error,mcimsg,MCIMSGLEN);
                MessageBox(hWnd,mcimsg,"Error",MB_ICONSTOP|MB_OK);
                return;
        }
        deviceid = open.wDeviceID;
        play.dwCallback = (DWORD)hWnd;

        MCI_Error = mciSendCommand(deviceid, MCI_PLAY, MCI_NOTIFY,(DWORD)&play);
        if (MCI_Error)
        {
                mciGetErrorString(MCI_Error,mcimsg,MCIMSGLEN);
                MessageBox(hWnd,mcimsg,"Error",MB_ICONSTOP|MB_OK);
        }
}

void drawtext(HDC hdc, int x, int y, char *str)
{
        RECT rect;

        SelectObject(hdc, GetStockObject(SYSTEM_FONT));

        rect.left = x;
        rect.right = x + (strlen(str) * 9);
        rect.top = y;
        rect.bottom = y+14;

        FillRect(hdc, &rect, GetStockObject(WHITE_BRUSH));
        DrawText(hdc, str, -1, &rect, 0);
}


long FAR PASCAL WndProc(HWND hWnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
        long i, fil, rifflen;
        char tempbuf[256];
        char *inbuffer, *outbuffer;
        HDC hdc;
        PAINTSTRUCT ps;
        static HANDLE hdlginstance;
        static HWND listbox, button, savebutton;

        switch (msg)
        {
                case WM_CREATE:
                hdlginstance = ((CREATESTRUCT far *) MK_FP32((void*)lparam))->hInstance;
                listbox = CreateWindow("LISTBOX","",WS_CHILD|WS_VISIBLE|WS_BORDER|LBS_STANDARD &~ LBS_SORT,23,32,160,300,hWnd,(HMENU)100,hdlginstance,NULL);
                CreateWindow("BUTTON","Save to file",WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,322,10,100,32,hWnd,(HMENU)64,hdlginstance,NULL);
                for(i=0;i<numitems;i++)
                        ListBox_AddItemData(listbox, item[i].name);
                break;
                case MM_MCINOTIFY:
                if (wparam == MCI_NOTIFY_SUCCESSFUL)
                {
                        mciSendCommand(deviceid, MCI_STOP, 0,(DWORD)NULL);
        		mciSendCommand(deviceid, MCI_CLOSE, 0, (DWORD)NULL);
			remove(".\\temp.wav");
			remove(".\\temp.mid");
                }
                break;
                case WM_COMMAND:
                switch(LOWORD(wparam))
                {
			case 1:
			strcpy(itemfilename, item[curitem].name);
                        ofn.lStructSize = sizeof(OPENFILENAME);
                        ofn.hwndOwner = hWnd;
                        ofn.hInstance = NULL;
                        ofn.lpstrFilter = "MIDI file (*.mid)\0*.mid\0";
                        ofn.lpstrDefExt = "mid";
                        ofn.nFilterIndex = 1;
                        ofn.lpstrFile = itemfilename; ofn.nMaxFile = sizeof(itemfilename);
                        ofn.lpstrFileTitle = tempbuf;
                        ofn.nMaxFileTitle = sizeof(tempbuf);
                        ofn.lpstrInitialDir = NULL;
                        ofn.lpstrTitle = "Save MIDI file";
                        ofn.Flags = OFN_SHOWHELP|OFN_PATHMUSTEXIST|OFN_OVERWRITEPROMPT;
                        if (GetSaveFileName(&ofn))
                        {
				sng2midi_main(ofn.lpstrFile, item[curitem].name);
                        }
			break;
			case 64:
			if (curitem >= 0)
			{
				strcpy(itemfilename, item[curitem].name);
                        	ofn.lStructSize = sizeof(OPENFILENAME);
                        	ofn.hwndOwner = hWnd;
                        	ofn.hInstance = NULL;
                        	ofn.lpstrFilter = "All files (*.*)\0*.*\0";
                        	ofn.lpstrDefExt = NULL;
                        	ofn.nFilterIndex = 1;
                        	ofn.lpstrFile = itemfilename; ofn.nMaxFile = sizeof(itemfilename);
                        	ofn.lpstrFileTitle = tempbuf;
                        	ofn.nMaxFileTitle = sizeof(tempbuf);
                        	ofn.lpstrInitialDir = NULL;
                        	ofn.lpstrTitle = "Save resource file";
                        	ofn.Flags = OFN_SHOWHELP|OFN_PATHMUSTEXIST|OFN_OVERWRITEPROMPT;
                        	if (GetSaveFileName(&ofn))
                        	{
					outbuffer = malloc(item[curitem].size);
					if (outbuffer == NULL)
					{
                                		MessageBox(hWnd,"Not enough memory to extract file","Out of memory",MB_OK);
                                		break;
					}
					fil = loaditem(item[curitem].name);
					readitem(fil,outbuffer,item[curitem].size);
					closeitem(fil);
                        		if ((fil = open(ofn.lpstrFile,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE)) == -1)
                        			break;
					write(fil,outbuffer,item[curitem].size);
					close(fil);
					free(outbuffer);
				}
			}
			break;
                        case 100:
                        if (HIWORD(wparam) == LBN_SELCHANGE)
                        {
                                curitem = ListBox_GetCurSel(listbox);
                                InvalidateRect(hWnd,NULL,1);
                        }
                        if ((strstr(item[curitem].name,".SNG") != 0) ||
                                (strstr(item[curitem].name,".RAW") != 0))
                        {
                                if (button == NULL)
                                        button = CreateWindow("BUTTON","Play",WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,322,99,64,32,hWnd,(HMENU)128,hdlginstance,NULL);
				if ((strstr(item[curitem].name,".SNG") != 0))
				{
					if (savebutton == NULL)
				        	savebutton = CreateWindow("BUTTON","Save as .MID",WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON,200,99,100,32,hWnd,(HMENU)1,hdlginstance,NULL);
				}
				else
				{
					if (savebutton != NULL)
					{
                                	        DestroyWindow(savebutton);
                                        	savebutton = NULL;
					}
				}
                        }
                        else
                        {
                                if (button != NULL)
                                {
                                        DestroyWindow(button);
                                        button = NULL;
                                }
				if (savebutton != NULL)
				{
                                        DestroyWindow(savebutton);
                                        savebutton = NULL;
				}
                        }
                        break;
                        case 101:
                        ofn.lStructSize = sizeof(OPENFILENAME);
                        ofn.hwndOwner = hWnd;
                        ofn.hInstance = NULL;
                        ofn.lpstrFilter = "Game data files\0sn*.dat\0Custom data files\0*.dat\0";
                        ofn.lpstrDefExt = "dat";
                        ofn.nFilterIndex = 1;
                        ofn.lpstrFile = datname; ofn.nMaxFile = sizeof(datname);
                        ofn.lpstrFileTitle = tempbuf;
                        ofn.nMaxFileTitle = sizeof(tempbuf);
                        ofn.lpstrInitialDir = NULL;
                        ofn.lpstrTitle = "Open DAT file";
                        ofn.Flags = OFN_SHOWHELP|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_OVERWRITEPROMPT;
                        if (GetOpenFileName(&ofn))
                        {
                                strcpy(datname, ofn.lpstrFile);
                                loadindex(ofn.lpstrFile);
                                ListBox_ResetContent(listbox);
                                for(i=0;i<numitems;i++)
                                {
                                        ListBox_AddItemData(listbox, item[i].name);
                                }
                        }
                        break;
                        case 102:
                        DestroyWindow(hWnd);
                        break;
                        case 110:
                        mciSendCommand(deviceid, MCI_STOP, 0,(DWORD)NULL);
        		mciSendCommand(deviceid, MCI_CLOSE, 0, (DWORD)NULL);
			remove(".\\temp.wav");
			remove(".\\temp.mid");
			break;
                        case 128:
                        if (strstr(item[curitem].name,".SNG") != 0)
                        {
				sng2midi_main(".\\temp.mid", item[curitem].name);
				playmidi(hWnd);
                        }
                        else
                        {
                                inbuffer = malloc(item[curitem].size);
                                if (inbuffer == NULL)
                                {
                                        MessageBox(hWnd,"Not enough memory to play sound","Out of memory",MB_OK);
                                        break;
                                }
                                outbuffer = malloc(item[curitem].size);
                                if (outbuffer == NULL)
                                {
                                        MessageBox(hWnd,"Not enough memory to play sound","Out of memory",MB_OK);
                                        break;
                                }
                                fil = loaditem(item[curitem].name);
                                readitem(fil,inbuffer,item[curitem].size);
                                closeitem(fil);
                                for(i=0;i<item[curitem].size;i++)
                                        outbuffer[i] = (signed char)(inbuffer[i] + 128);
                                if ((fil = open(".\\temp.wav",O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE)) == -1)
                                        break;
                                write(fil,&wavehdr[0],sizeof(wavehdr));
                                write(fil,&item[curitem].size,4);
                                write(fil,outbuffer,item[curitem].size);
				lseek(fil,4,SEEK_SET);
				rifflen = ROUND_UP_TO_EVEN(item[curitem].size)+36;
				write(fil,&rifflen,4);
                                close(fil);
                                free(inbuffer);
                                free(outbuffer);
                                playwave(hWnd);
                        }
                        break;
                }
                break;
                case WM_PAINT:
                hdc = BeginPaint(hWnd, &ps);
                if (curitem >= 0)
                    sprintf(tempbuf, "Size: %d", item[curitem].size);
                else
                    strcpy(tempbuf, "Size: N/A");
                drawtext(hdc, 320, 48, tempbuf);
                if (curitem >= 0)
                    sprintf(tempbuf, "Offset: %d", item[curitem].offset);
                else
                    strcpy(tempbuf, "Offset: N/A");
                drawtext(hdc, 320, 72, tempbuf);
                EndPaint(hWnd, &ps);
                return(0);
                case WM_DESTROY:
		remove(".\\temp.wav");
		remove(".\\temp.mid");
		PostQuitMessage(0);
                break;
        }
        return(DefWindowProc(hWnd, msg, wparam, lparam));
}

